#!/usr/local/bin/perl -w

use Lingua::Lojban qw(gismu rafsi2gismu rafsi4gismu make_lujvo gismulist 
                      split_lujvo);

@gismu = gismulist();

$howmany = 200;
$forever = 0;

$howmany = $ARGV[0] if $ARGV[0];
$forever = 1 if $ARGV[0] eq "forever";

for ($n = 1; $forever or $n < $howmany+1; $n++) {
    my $count = int(rand(3)) + 2;
    my(@g);
    foreach (1 .. $count) {
	my $g;
	do {
	    $g = $gismu[rand(@gismu)];
	} until ($g !~ /^brod/);
	push(@g, $g);
    }
    print "$n: ",join('+',@g)," (";
    my (@e) = map { (gismu($_))->{'english'} } @g;
    print join('+', @e), ") : ";
    my(@lujvo) = make_lujvo(@g);
#    foreach (@lujvo) {
#	print " $_\n";
#    }
    print "$lujvo[0]\n";
    my(@s) = split_lujvo($lujvo[0]);
    die "couldn't split" unless @s;
    #print join(':',@s),"\n";
    # test
    foreach (0 .. $#g) {
	if ($s[$_] ne $g[$_]) {
	    die "didn't match";
	}
    }
}
